//spaces in names
#include "AimBuddyConv.h"
#include <iostream.h>
#include "string.h"
#include <fstream.h>
#include "Say.h"


void killfirst(char* str)
{
  int p=-1;
  while (str[++p]!='\0')
    str[p]=str[p+1];
}

bool strcomp(char one[MAX_STR], char two[MAX_STR], int upto)
{
  int p=0; upto--;
  while ((one[p]!='\0') && (one[p]==two[p]) && (p<=upto))
    p++;
  return (one[p]==two[p]);
}

void ReadLine(ifstream& input, char line[MAX_STR], bool removetabs)
{
  int p=-1;
  do {
    if ((p!=-1) && removetabs && (line[p]=='\t')) p--;
    p++;
    input.get(line[p]);
  } while ((line[p]!='\n') && input && (p<MAX_STR));
  line[p]='\0';
}

void ReadOldBe(ifstream& input, group* &list)
{
  int p;
  group* tempgroup=NULL;
  person* tempperson=NULL;
  char line[MAX_STR];
  while (input)
  {
    ReadLine(input, line, false);
    if (line[0]=='g')
    {
      if (list==NULL)
      {
        list = new group;
        tempgroup=list;
      }
      else
      {
        tempgroup->next = new group;
        tempgroup = tempgroup->next;
      }
      tempgroup->scrnname = NULL;
      fflush(stdout);
      killfirst(line);
      strcpy(tempgroup->name, line);
      tempgroup->next = NULL;
    }
    else if (line[0]=='p')
    {
      if (tempgroup->scrnname==NULL)
      {
        tempgroup->scrnname = new person;
        tempperson=tempgroup->scrnname;
      }
      else
      {
        tempperson->next = new person;
        tempperson = tempperson->next;
      }
      killfirst(line);
      p=0;
      while ((line[p]!='\t') && (line[p]!='\0'))
        tempperson->name[p] = line[p++];
      tempperson->name[p]='\0';
      tempperson->next = NULL;
    }
  }
}

void ReadBe(ifstream& input, group* &list)
{
  int p;
  group* tempgroup=NULL;
  person* tempperson=NULL;
  char line[MAX_STR];
  while (input)
  {
    ReadLine(input, line, true);
    if (strcomp(line, "<group", 5))
    {
      if (list==NULL)
      {
        list = new group;
        tempgroup=list;
      }
      else
      {
        tempgroup->next = new group;
        tempgroup = tempgroup->next;
      }
      p=13;
      tempgroup->scrnname = NULL;
      while ((line[p]!='\"') && (line[p]!='\0'))
        tempgroup->name[p-13] = line[p++];
      tempgroup->name[p-13]='\0';
      tempgroup->next = NULL;
    }
    else if( strcomp(line,"<buddy",5) && !strcomp(line,"<buddylist",9) )
    {
      if (tempgroup->scrnname==NULL)
      {
        tempgroup->scrnname = new person;
        tempperson=tempgroup->scrnname;
      }
      else
      {
        tempperson->next = new person;
        tempperson = tempperson->next;
      }
      p=13;
      while ((line[p]!='\"') && (line[p]!='\0'))
        tempperson->name[p-13] = line[p++];
      tempperson->name[p-13]='\0';
      tempperson->next = NULL;
    }
  }
}

void ReadWin(ifstream& input, group* &list)
{
  int p;
  group* tempgroup=NULL;
  person* tempperson=NULL;
  char line[MAX_STR];
  while (input)
  {
    ReadLine(input, line, true);
    if (strcomp(line, "group", 4))
    {
      if (list==NULL)
      {
        list = new group;
        tempgroup=list;
      }
      else
      {
        tempgroup->next = new group;
        tempgroup = tempgroup->next;
      }
      p=7;
      while ((line[p]!='\"') && (line[p]!='\0'))
        tempgroup->name[p-7] = line[p++];
      tempgroup->name[p-7]='\0';
      tempgroup->next = NULL;
    }
    else if (strcomp(line, "buddy", 4))
    {
      if (tempgroup->scrnname==NULL)
      {
        tempgroup->scrnname = new person;
        tempperson=tempgroup->scrnname;
      }
      else
      {
        tempperson->next = new person;
        tempperson = tempperson->next;
      }
      p=7;
      while ((line[p]!='\"') && (line[p]!='\0'))
        tempperson->name[p-7] = line[p++];
      tempperson->name[p-7]='\0';
      tempperson->next = NULL;
    }
  }
}


void ReadGAIM(ifstream& input, group* &list)
{
  int p;
  group* tempgroup=NULL;
  person* tempperson=NULL;
  char line[MAX_STR];
  while (input)
  {
    ReadLine(input, line, true);
    if (strcomp(line, "m ", 1))
        continue;
    if (strcomp(line, "g ", 1))
    {
      if (list==NULL)
      {
        list = new group;
        tempgroup=list;
      }
      else
      {
        tempgroup->next = new group;
        tempgroup = tempgroup->next;
      }
      p=2;
      while ((line[p]!='\n') && (line[p]!='\0'))
        tempgroup->name[p-2] = line[p++];
      tempgroup->name[p-2]='\0';
      tempgroup->next = NULL;
    }
    else if (strcomp(line, "b ", 1))
    {
      if (tempgroup->scrnname==NULL)
      {
        tempgroup->scrnname = new person;
        tempperson=tempgroup->scrnname;
      }
      else
      {
        tempperson->next = new person;
        tempperson = tempperson->next;
      }
      p=2;
      while ((line[p]!='\n') && (line[p]!='\0'))
        tempperson->name[p-2] = line[p++];
      tempperson->name[p-2]='\0';
      tempperson->next = NULL;
    }
  }
}


void NukeList( group* list ) {

	group* list2;
	person *temp, *temp2;
	while (list!=NULL)
	{
		temp = list->scrnname;
		while (temp!=NULL)
		{
			temp2 = temp->next;
			delete temp;
			temp = temp2;
		}
		list2 = list->next;
		delete list;
		list = list2;
	}
}


void ImportAIMList( entry_ref& ref, group*& list, int type ) {

	BString pathski;

	// conversion vars
	ifstream input;
	list=NULL;

	// path vars
	BPath path;
	BEntry entry(&ref);
	entry.GetPath(&path);
	pathski = path.Path();
	
	// sanity check
	if( !entry.Exists() )
		return;

	// read that bad boy
	input.open( pathski.String() );
	if( type == 1 )
		ReadWin(input, list);
	else if( type == 2 )
		ReadOldBe(input, list);
	else if( type == 3  )
		ReadBe(input, list);
	else if( type == 4  )
		ReadGAIM(input, list);
	input.close();
}
