#ifndef MISC_STUFF_H
#define MISC_STUFF_H

#include "constants.h"
#include <String.h>
#include <View.h>

void GetBitmapFromResources( BBitmap*& themap, int32 resid, char *resfile = NULL );
void MakeButtonPicture( BPicture*& themap, BView* view, int32 resid, char *resfile = NULL );
int ConvertFontSize( int );
void PostAppMessage( BMessage* msg );
void MakeFilenameFromUsername( char* fullpath, char* username );
void SquishScreenName( char* username );
bool CompareScreenNames( char* a, char* b );

bool isValidColor( BString );
BString ColorToString( rgb_color );
rgb_color StringToColor( BString );

#endif
